#!bin/bash
#
#  Make dev for NFS rootfile system
# 
#
ROOTFSJFFS2=`dirname $ROOTFILESYS`/root
ROOTFSNFS=`dirname $ROOTFILESYS`/nfs

if [ "x$1" = "x" ]; then
	sec=7;y=$sec
	echo "** no device_table argument given ! **"
	DEVICE_TABLE=$CONFIG/device_table${DATE}.txt	
	echo -en "Using defaults :  $DEVICE_TABLE. \nAuto continue in $sec seconds..."
		while [ $y -gt 0 ];do
			sleep  1
			y=`expr $y - 1`
			echo -n "$y..."	
		done
		echo 
	else
	DEVICE_TABLE="$1"	
fi
i=0


process_make_cmd()
{

                        #cmd is :
                        #<name>         <type>  <mode>  <uid>   <gid>   <major> <minor> <start> <inc>   <count>
                        name="$1"
                        type="$2"
                        mode="$3"
                        uid="$4"
                        gid="$5"
                        major="$6"
                        minor="$7"
                        start="$8"
                        inc="$9"
			shift
                        count="$9"

	[ "x$name" = "x" ] || [ "x$type" = "x" ] && return 1
	[ "x$mode" = "x" ] && mode=644
	[ "x$uid" = "x" ] && uid=0
	[ "x$gid" = "x" ] && gid=0
	[ "x$start" = "x" -o  "x$start" = "x-" ] && start=0
        [ "x$inc" = "x" -o  "x$inc" = "x-" ] && inc=0
	[ "x$count" = "x" -o "x$count" = "x-"  ] && count=0

	# coherence
	[ $count -eq 0 ] && inc=0

	# prefix towards rootfile system
	name="$ROOTFSNFS/$name"


	while [ $start -le $count ]
	do 
		# Don't append 0 at end of name
		[ $start -eq $count ] && [ $start -eq 0 ] && start= 
		case "$type" in
			d)
				mkdir -p "${name}$start"
				break;;
			f)
				touch "${name}$start"
				break;;
			c|b)	
				mknod "${name}$start" $type $major $minor >/dev/null 2>/dev/null
				break;;
			p)
				mkfifo "${name}$start"
				break;;
		esac
		chmod $mode ${name}
		chown $uid ${name}
		chgrp $gid ${name}
		start=`expr $start + $inc`
		# Do not get stuck in here ...
		[ $inc -eq 0 ] && break
	done
}


for line in `cat $DEVICE_TABLE | egrep -v "^#" | tr -s ' ' '\t' | tr -s '\t' | sort `
do
	cmd="$cmd $line"
	i=`expr $i + 1`
		if [ $i -eq 10 ]; then 
			i=0
			process_make_cmd $cmd
			cmd=""
		fi
	
done
