#! /bin/sh
#
# Starts clock... 
#	CASE A . If a timekeeping device maintain the hardware-clock then
#  		A optionnal "soft clock reference" is stored as last system shutdown date.
#	CASE B . If not, then date is not maintain across reboots,
#		then "soft clock" stored is used to restore time on the basis of
#		last system shutdown date. Is is better than nothing at all !
#
# $1 : Modus operandi {start|stop}
# ret: {0:process all ok | 1:part/whole process failed}
#
# $ mercredi 10/05/05 08:50:12 md(root) mathieu.deschamps@com2gether.net$
#
##
DATEFILE=/etc/DF
# Set this to nothing if CASE A or what-ever-u-want if CASE B.
TYPECLOCK=
##
#
#
MODUS=$1
# Maybe its run as a non rcS-launcher call (ie manual call)
[ "x$VERBOSE" = "x" ] && VERBOSE=no

#
# String formating date function. Store/retrieve date  depending on
# 	$1: {save | retrieve } 
#	$2: Date file
#	$3: call from a manual date setup ? (true is non-void)
# returns { 0 : ok | 1 : error | 99 : invalid parameters }
#
#
formatdate()
{
	CMD="$1"
	SPE="$3"	
	[ "x$2" != "x" ] && datefil="$2" || return 99
	case "$CMD" in	
	 	save) 	
			year=`/bin/date +%F | cut -f1 -d "-"`
			monthday=`/bin/date +%F | cut -f2-3 -d "-"`
			hourmin=`/bin/date +%H-%M`
			sec=`/bin/date +%S`
			RECEPT=`echo "$monthday$hourmin$year.$sec" | tr -d "-"`
			[ "$VERBOSE" = yes ] && echo -en "\t Saving datestring $RECEPT to $datefil..."
				echo $RECEPT > $datefil
				RET=$?
		;;
		retrieve)
			if [ "x$3" != "x" ]; then
				# retrieve a "soft clock" to set hardware-clock with 
				# manual time setting only !
				RECEPT=`cat $datefil | grep -v "^#"`
				[ "$VERBOSE" = yes ] && echo "Doing date -s $RECEPT"
					date -s "$RECEPT" >/dev/null 2>&1
					RET=$?
			else
				# most of the time do nothing
					RET=0
			fi
		;;
		""|*)
				RET=99
		;;
	esac	
	return $RET
}



start()
{
			SPECIAL="$1"
			echo -n "Retrieving hardware clock..."
		if [ ! -r $DATEFILE ]; then 
			echo -e "\tImpossible to retrieve date file $DATEFILE. System is not synchronized !"
			return 1
		fi
				
				formatdate retrieve $DATEFILE $SPECIAL
				if [ $? -ne 0 ]; then
					echo -e "\tError in retreiving formatdate. System is not synchronized !"
					return 1
				fi
				if [ "x$SPECIAL" != "x" ]; then 
					# Write to hardware-clock we're restarted upon manual time setting
					/sbin/hwclock -w 
				else
					# Normal/standard start, retrieve hardware-clock
					/sbin/hwclock -s
				fi
					
		echo "done."
	return 0	
}

stop()
{
			echo -n "Saving hardware clock..."
			/sbin/hwclock -s

		if [ ! -e $DATEFILE ]; then
                        echo -e "\tWarning : no date file $DATEFILE where found on system, creating one..."
	                        touch $DATEFILE; 
			if [ $? -ne 0 ] || [ ! -w $DATEFILE ]; then 
				echo -e "\tUnable to create $DATEFILE, write forbidden. System won't be synchronized !"
				return 1
			fi
		fi
			
		if [ ! -w $DATEFILE ]; then
			echo -e "\tUnable to write to $DATEFILE, it's forbidden. System won't be synchronized !"
			return 1
		fi
				# normal processing but may also be recovering for error
				chmod 644 $DATEFILE;
                                formatdate save $DATEFILE
				if [ $? -ne 0 ]; then	
					echo -e "\tError in saving date to $DATEFILE. System might be unsynchronized at next startup!"	
					return 1
				fi
		echo "done."
	return 0
}

case "$1" in
	start|"")	start $TYPECLOCK
		;;
	stop)		stop
		;;

	restart)	stop
			start
		;;

	manual)		stop
			if [ ! -w $DATEFILE ]; then 
				echo -e "\t Unable to write to $DATEFILE, that's forbidden. You won't be able to set date, sorry." 
			fi
			echo -e "\nManually set date\n Enter date like this [type1(format1)type2(format2)...typeN(formatN)]: \n "
			echo -e "NOTE: hours are 24h \n\t Type in format is month(mm)day(dd)hour(hh)minute(mm)year(yyyy).seconde(ss) :" 
			read RECEPT
			echo $RECEPT > $DATEFILE
			echo -e "\n"
			start manual
		;;
	*)
                echo "Usage: S01clock {start|stop|restart}" >&2
                exit 1
                ;;

esac

unset RECEPT
exit $?

