#! /bin/sh
#
# Set serial ports
#
#
# $1 : Modus operandi {start|stop|restart}
# $ Wednesday 05/31/06 08:26:16 mathdesc mathieu.deschamps@com2gether.net$
#
#
##
INTFILE=/etc/network/interfaces
NETSERV=/etc/network/interfaces.service
LISTPORT="/dev/ttyS0 /dev/ttyS1 /dev/ttyS3 /dev/ttyS4 /dev/ttyS5 /dev/ttyS6"
HHSPORT="/dev/ttyS5 /dev/ttyS6"
##
#
#
MODUS=$1
# Maybe its run as a non rcS-launcher call (ie manual call)
[ "x$VERBOSE" = "x" ] && VERBOSE=no
[ "x$2" != "x" ] && SPEED="$2" || SPEED=115200



start () {
	echo -n "Setting TTYs dumb and raw at $SPEED Bauds ..."
	
	for port in $LISTPORT
	do
		
		stty -F $port raw -echo -onlcr $SPEED  >/dev/null
		[ $? -ne 0 ] && echo "Error while setting tty $port" || echo -n "$port "
	done

	echo ".done."
}
stop () {
	echo -n "Unsetting TTY back to sane state..."
		
        for port in $LISTPORT
        do
                stty -F $port sane >/dev/null
                [ $? -ne 0 ] && echo "Error while setting tty $port" || echo -n "$port "
        done

	echo ".done."
}

enable_handshake () {
	echo -n "Enabling hardware handshake at $SPEED Bauds ..."

        for port in $HHSPORT
        do
                stty -F $port crtscts $SPEED >/dev/null
                [ $? -ne 0 ] && echo "Error while setting tty $port" || echo -n "$port "
        done
	
	echo ".done."
}

disable_handshake () {
	echo -n "Disable hardware hanshake on ..."

        for port in $HHSPORT
        do
                stty -F $port -crtscts >/dev/null
                [ $? -ne 0 ] && echo "Error while setting tty $port" || echo -n "$port "
        done

	echo ".done."
}

restart () {
	stop 
	start
}


case "$1" in
	start|"")
		start $SPEED
		enable_handshake $SPEED
		;;
	stop)
		disable_handshake $SPEED
		stop $SPEED
		;;
	handshakeon|hardwarehandshakeon|hhson|hardon)
		enable_handshake $SPEED
		;;
        handshakeoff|hardwarehandshakeoff|hhsoff|hardoff)
                disable_handshake $SPEED
                ;;
	restart)
		restart $SPEED
		;;
	*)
		echo $"Usage: $0 {start|stop|restart}"
	        exit 1
		;;
esac

exit $?
